//
//  BizListTableViewController.m
//  Messangi
//
//  Created by Christopher Choitz on 8/18/14.
//  Copyright (c) 2014 Ogangi. All rights reserved.
//

#import "BizListTableViewController.h"



@interface BizListTableViewController ()

@property (nonatomic, strong) NSArray *bizList;

@end

@implementation BizListTableViewController


- (void)viewDidLoad
{
    NSString *bizDirectory = [Business businessDirectory];
    NSArray *fileList = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:bizDirectory error:nil];
    
    // Filter list to where it only shows plist files.
    fileList = [fileList filteredArrayUsingPredicate:[NSPredicate predicateWithFormat:@"pathExtension ==[c] %@", @"plist"]];
    _bizList = [[NSArray alloc] initWithArray:fileList];
    _currentFileNameSelected = @"";
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return _bizList.count;
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier: @"BizListCell"];
    
    cell.textLabel.text = [_bizList[indexPath.row] stringByDeletingPathExtension];
    
    if ([[_currentFileNameSelected stringByDeletingPathExtension] isEqualToString:cell.textLabel.text]) {
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    }
    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    [tableView deselectRowAtIndexPath:indexPath animated:NO];
    NSInteger fileIndex = [_bizList indexOfObject:_currentFileNameSelected];
    UITableViewCell *newCell = [tableView cellForRowAtIndexPath:indexPath];
    
    if (fileIndex == indexPath.row) {
        _currentFileNameSelected = @"";
        newCell.accessoryType = UITableViewCellAccessoryNone;
    } else {
        newCell.accessoryType = UITableViewCellAccessoryCheckmark;
        self.currentFileNameSelected = [_bizList objectAtIndex:indexPath.row];
        NSIndexPath *oldIndexPath = [NSIndexPath indexPathForRow:fileIndex inSection:0];
        UITableViewCell *oldCell = [tableView cellForRowAtIndexPath:oldIndexPath];
        oldCell.accessoryType = UITableViewCellAccessoryNone;
    }
}


@end
