//
//  SubscriptionsTableViewController.m
//  Messangi
//
//  Created by Robert Volante on 7/14/14.
//  Copyright (c) 2014 Ogangi. All rights reserved.
//

#import "SubscriptionsTableViewController.h"
#import <MessangiSDK/MessangiSDK.h>
#import <CoreLocation/CoreLocation.h>

@interface SubscriptionsTableViewController ()

@property (nonatomic, strong) NSString *geoFenceDirectory;

@end

@implementation SubscriptionsTableViewController

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewWillAppear:(BOOL)animated
{
    [self.tableView reloadData];
    
    self.tabBarController.tabBar.hidden = YES;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    _screenTitleSubscriptions.title = NSLocalizedString(@"Subscriptions", @"Instances of the word Subscriptions");
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    NSInteger deleteThis = [[Messangi sharedInstance].subscriptionsList count];
    return deleteThis;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"SubscriptionCell" forIndexPath:indexPath];
    
    Subscription *subscription = [Messangi sharedInstance].subscriptionsList[indexPath.row];
    
    cell.textLabel.text = [NSString stringWithFormat:@"%@", subscription.name];
    
    //If row's subscription id is in the array of list of distribution list id's the device is registered to
    if ([subscription isSaved]) {
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    } else {
        cell.accessoryType = UITableViewCellAccessoryNone;
    }
    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    Subscription *subscription = [Messangi sharedInstance].subscriptionsList[indexPath.row];
    
    if ([tableView cellForRowAtIndexPath:indexPath].accessoryType == UITableViewCellAccessoryCheckmark) {
        [[Messangi sharedInstance] unsubscribeFromList:subscription.subID];
        [subscription deleteSub];
    } else if ([tableView cellForRowAtIndexPath:indexPath].accessoryType == UITableViewCellAccessoryNone) {
        [[Messangi sharedInstance] subscribeToList:subscription.subID];
        [subscription writeSubToFile];
        
    }
    [tableView reloadData];
}

@end
