//
//  MyScene.m
//  SoccerKeeper
//
//  Created by Oscar Anzola on 8/8/14.
//  Copyright (c) 2014 WayApp. All rights reserved.
//

#import "iBeaconSignalScene.h"

@implementation iBeaconSignalScene {
    SKSpriteNode *_signal;
    NSArray *_signalRollingFrames;
}

-(id)initWithSize:(CGSize)size {    
    if (self = [super initWithSize:size]) {
        
        //Setup the array to hold the walking frames
        
        NSMutableArray *rollingFrames = [NSMutableArray array];
        SKTextureAtlas *ballAnimatedAtlas = [SKTextureAtlas atlasNamed:@"iBeaconSignal"];
        
        self.backgroundColor = [UIColor whiteColor];
        for (int i=0; i <= 7; i++) {
            NSString *textureName = [NSString stringWithFormat:@"iBeaconSignal%d.png", i];
            SKTexture *temp = [ballAnimatedAtlas textureNamed:textureName];
            [rollingFrames addObject:temp];
        }
        _signalRollingFrames = rollingFrames;
        
        SKTexture *temp = _signalRollingFrames[0];
        CGSize newSize = CGSizeMake(128.0, 128.0);
        _signal = [SKSpriteNode spriteNodeWithTexture:temp size:newSize];
        _signal.position = CGPointMake(CGRectGetMidX(self.frame), CGRectGetMidY(self.frame));
        [self addChild:_signal];
    }
    return self;
}

-(void)stopEmittingSignal
{
    [_signal removeAllActions];
}

-(void)startEmittingSignal:(float)speed
{
    [_signal runAction:[SKAction repeatActionForever:[SKAction animateWithTextures:_signalRollingFrames
                                                                    timePerFrame:speed
                                                                          resize:NO
                                                                         restore:YES]] withKey:@"ballRolling"];
    return;
}

-(void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
  
    [self startEmittingSignal:0.5];
}


@end
