#import "iBeaconUUIDViewController.h"
#import "iBeaconDefaults.h"

@interface iBeaconUUIDViewController ()

@end

@implementation iBeaconUUIDViewController

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [iBeaconDefaults sharedDefaults].supportedProximityUUIDs.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    
    if(indexPath.row < [iBeaconDefaults sharedDefaults].supportedProximityUUIDs.count)
    {
        cell.textLabel.text = [[iBeaconDefaults sharedDefaults].supportedProximityUUIDs[indexPath.row] UUIDString];
        if([self.uuid isEqual:[iBeaconDefaults sharedDefaults].supportedProximityUUIDs[indexPath.row]])
        {
            cell.accessoryType = UITableViewCellAccessoryCheckmark;
        }
    }
    
    return cell;
}

#pragma mark - Navigation

// In a story board-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    NSIndexPath * selectionIndexPath = [self.tableView indexPathForSelectedRow];
    NSInteger selection;

    if(selectionIndexPath.row < [iBeaconDefaults sharedDefaults].supportedProximityUUIDs.count)
    {
        selection = selectionIndexPath.row;
    }
    else
    {
        selection = 0;
    }

    self.uuid = [iBeaconDefaults sharedDefaults].supportedProximityUUIDs[selection];
}

@end
