//
//  checkGeoFences.h
//  Messangi
//
//  Created by Omar Diaz on 10/04/14.
//  Copyright (c) 2014 Ogangi. All rights reserved.
//

#ifndef checkGeoFences_H
#define checkGeoFences_H

#import <Foundation/Foundation.h>
#import <CoreLocation/CoreLocation.h>
#import <UIKit/UIKit.h>

@protocol CheckGeoFencesDelegate <NSObject>
@required
- (void) checkGeoFencesSuccess:(NSMutableArray*)updatedGeoFences;
- (void) checkGeoFencesReturnedError:(NSString *)error;
@end

@interface CheckGeoFences : NSObject <NSXMLParserDelegate>
{
    NSMutableString *currentStringValue;
    NSString *currentProperty;
    id <CheckGeoFencesDelegate> delegate;
    
    void (^completion)(UIBackgroundFetchResult);
}

@property BOOL successful;
@property (strong) CLCircularRegion *currentRegion;
@property CLLocationDistance currentRegionRadius;
@property CLLocationCoordinate2D currentRegionCenter;
@property (nonatomic, strong) NSString *currentRegionIdentifier;
@property (nonatomic, strong) NSString *currentRegionEventType;
@property (nonatomic, strong) NSString *currentRegionEventTitle;
@property (strong) NSMutableArray *geofences;
@property int operation;
@property (retain) id delegate;
@property (nonatomic, strong) NSMutableString *currentStringValue;
@property (nonatomic, strong) NSString *currentProperty;


-(void)getUpdatedGeoFencesWithCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler;

@end

#endif