//
//  LoadBeacons.h
//  MessangiSDK
//
//  Created by Oscar Anzola on 8/26/14.
//  Copyright (c) 2014 Ogangi. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreLocation/CoreLocation.h>
#import <UIKit/UIKit.h>

@protocol LoadBeaconsDelegate <NSObject>
@required
- (void) loadBeaconsSuccess:(NSMutableArray*)updatedGeoFences;
- (void) loadBeaconsReturnedError:(NSString *)error;
@end

@interface LoadBeacons : NSObject <NSXMLParserDelegate>

@property BOOL successful;
@property (strong) CLBeaconRegion *currentRegion;
@property NSUUID *currentRegionUUID;
@property CLBeaconMajorValue currentRegionMajor;
@property CLBeaconMinorValue currentRegionMinor;
@property (nonatomic, strong) NSString *currentRegionIdentifier;
@property (nonatomic, strong) NSString *currentRegionEventType;
@property (nonatomic, strong) NSString *currentRegionEventTitle;
@property NSInteger currentRegionDistance;
@property (strong) NSMutableArray *beacons;
@property int operation;
@property (retain) id delegate;
@property (nonatomic, strong) NSMutableString *currentStringValue;
@property (nonatomic, strong) NSString *currentProperty;


-(void)getUpdatedBeaconsWithCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler;

@end
