//
//  DeviceSuscriber.m
//  ego
//
//  Created by Jose V. Salazar on 12/15/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "MessangiAPI.h"
#import "DeviceSubscriber.h"
#import "Messangi.h"

@implementation DeviceSubscriber


- (id)init {
	if (!self) {
		self = [super init];
	}

	return self;
}

- (void)registerDeviceWithUniqueID {
	NSLog(@"register Device With Unique ID");

	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];

	double timeStamp = ((double)[[NSDate date]timeIntervalSince1970]) * 1000;

	NSString *stringToSign = [NSString stringWithFormat:@"%@/%@/%@/%@/%F", [defaults objectForKey:@"deviceUniqueID"], [Messangi sharedInstance].appName, [defaults objectForKey:@"devicePushID"], [Messangi sharedInstance].clientID, timeStamp];

    NSString *encodedStringToSign = [stringToSign stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLPathAllowedCharacterSet]];

    NSString *signedString = [MessangiAPI encodeString:stringToSign usingKey:[Messangi sharedInstance].apiClientPrivateKey];

	NSString *urlString = [NSString stringWithFormat:@"%@/iOSReg/%@/%@", PREFIX, encodedStringToSign, signedString];
    NSLog(@"urlString = %@",urlString);

    NSURLSession* mySession = [NSURLSession sharedSession];
    NSURLSessionTask* task = [mySession dataTaskWithURL:[NSURL URLWithString:urlString]
                                        completionHandler:^(NSData* data,
                                                            NSURLResponse* response, NSError* error) {
                                            if (error == nil)
                                            {
                                                NSLog(@"iOSReg: completed successfully");
                                                NSXMLParser *parser = [[NSXMLParser alloc] initWithData:data];
                                                parser.delegate = self;
                                                [parser parse];
                                            }
                                            else
                                            {
                                                NSLog(@"iOSReg: completed with error: %@", [error localizedDescription]);
                                            }
                                        }];
    [task resume];
}

- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary *)attributeDict {
	_currentProperty = elementName;

	return;
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string {
	if (!self.currentStringValue) {
		// currentStringValue is an NSMutableString instance variable
		self.currentStringValue = [[NSMutableString alloc] initWithCapacity:50];
	}
	[self.currentStringValue appendString:string];
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName {
	if (([elementName isEqualToString:@"transactionResult"])) {
		return;
	}


	NSString *prop = [self currentProperty];



	if ([prop isEqualToString:@"message"]) {
		self.message = _currentStringValue;
	}

	if ([prop isEqualToString:@"successful"]) {
		if ([_currentStringValue isEqual:@"true"])
			self.successful = YES;
		else
			self.successful = NO;
	}
	_currentStringValue = nil;
}

- (void)parserDidStartDocument:(NSXMLParser *)parser {
}

- (void)parser:(NSXMLParser *)parser parseErrorOccurred:(NSError *)parseError {
}

@end
