//
//  EventLogger.m
//  MessangiSDK
//
//  Created by Francisco Andrades Grassi on 1/2/15.
//  Copyright (c) 2015 Ogangi. All rights reserved.
//

#import "EventLogger.h"
#import "MessangiAPI.h"
#import "Messangi.h"

@implementation EventLogger


+(void)logEvent: (NSString *) eventType andExtraInfo:(NSString *) extraInfo withCampaignName: (NSString *) campaignName
{
    
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    
    NSString *prefix = @"https://api.messangi.com/events/?";
    
    NSString *clientId = [Messangi sharedInstance].clientID;
    NSString *appName = [[Messangi sharedInstance].appName stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLPathAllowedCharacterSet]];
    NSString *platform = @"IOS";
    CLLocation *location = [Messangi sharedInstance].messangiLastLocation;
    NSString *deviceUniqueID = [defaults objectForKey:@"deviceUniqueID"];
    NSString *mobile = [defaults objectForKey:@"clientPhoneNumber"];
    NSString *version = @"2.6.1";
    
    NSMutableString *url = [NSMutableString stringWithFormat:@"%@deviceid=%@&client=%@&app=%@&platform=%@&eventtype=%@", prefix, deviceUniqueID, clientId, appName, platform, [eventType stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLPathAllowedCharacterSet]]];
    
    if (location != nil) {
        [url appendString:[NSString stringWithFormat:@"&latitude=%f&longitude=%f", location.coordinate.latitude, location.coordinate.longitude]];
    }
    
    if (mobile != nil) {
        [url appendString:[NSString stringWithFormat:@"&mobile=%@", [mobile stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLPathAllowedCharacterSet]]]];
    }
    
    if (extraInfo != nil) {
        [url appendString:[NSString stringWithFormat:@"&extrainfo=%@", [extraInfo stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLPathAllowedCharacterSet]]]];
    }

    if (campaignName != nil){
        [url appendString:[NSString stringWithFormat:@"&campaign_name=%@",[campaignName stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLPathAllowedCharacterSet]]]];
    }
    
    [url appendString:[NSString stringWithFormat:@"&version=%@", version]];
    NSLog(@"urlString :%@",url);
    
    NSURLSession* mySession = [NSURLSession sharedSession];
    NSURLSessionTask* task = [mySession dataTaskWithURL:[NSURL URLWithString:url]
                                      completionHandler:^(NSData* data,
                                                          NSURLResponse* response, NSError* error) {
                                          if (error == nil)
                                          {
                                              NSLog(@"eventType: completed successfully");
                                          }
                                          else
                                          {
                                              NSLog(@"eventType: completed with error: %@", [error localizedDescription]);
                                          }
                                      }];
    [task resume];
}

@end
