//
//  MessangiAPI.m
//  Messangi
//
//  Created by Oscar Anzola on 6/26/14.
//  Copyright (c) 2014 Ogangi. All rights reserved.
//

#import "MessangiAPI.h"
#import <CommonCrypto/CommonHMAC.h>


@implementation MessangiAPI


+ (NSString *)NSDataToNSString:(NSData *)NSDataBytes {
	const unsigned *tokenBytes = [NSDataBytes bytes];
	NSString *hexToken = [NSString stringWithFormat:@"%08x%08x%08x%08x%08x%08x%08x%08x",
	                      ntohl(tokenBytes[0]), ntohl(tokenBytes[1]), ntohl(tokenBytes[2]),
	                      ntohl(tokenBytes[3]), ntohl(tokenBytes[4]), ntohl(tokenBytes[5]),
	                      ntohl(tokenBytes[6]), ntohl(tokenBytes[7])];
	return hexToken;
}

+ (NSString *)encodeString:(NSString *)data usingKey:(NSString *)key {
	const char *cKey  = [key cStringUsingEncoding:NSASCIIStringEncoding];
	const char *cData = [data cStringUsingEncoding:NSASCIIStringEncoding];
	unsigned char cHMAC[CC_SHA256_DIGEST_LENGTH];
	CCHmac(kCCHmacAlgSHA256, cKey, strlen(cKey), cData, strlen(cData), cHMAC);

	NSData *HMAC = [[NSData alloc] initWithBytes:cHMAC length:sizeof(cHMAC)];

	NSString *hexToken = [self NSDataToNSString:HMAC];

	return hexToken;
}

@end
