//
//  SingleMessageLoader.h
//  ego
//
//  Created by Jose V. Salazar on 1/4/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "UnstoredIncomingMessage.h"
#import <UIKit/UIKit.h>

@protocol SingleMessageLoaderDelegate <NSObject>
@required
- (void) messageLoadFinishedReturningMessage:(UnstoredIncomingMessage *)message;
- (void) dataloaderReturnedError:(NSString *)error;
@end


@interface SingleMessageLoader : NSObject <NSXMLParserDelegate>
{
    NSString *statusCode;
    NSString *statusDescription;
    UnstoredIncomingMessage *currentMessage;

    NSMutableString *currentStringValue;
    NSString *currentProperty;
    id <SingleMessageLoaderDelegate> delegate;
    
    void (^completion)(UIBackgroundFetchResult);
    
}


@property (strong) NSString *statusCode;
@property (strong) NSString *statusDescription;
@property (strong) UnstoredIncomingMessage *currentMessage;
@property (retain) id delegate;
@property (nonatomic, strong) NSMutableString *currentStringValue;
@property (nonatomic, strong) NSString *currentProperty;

@property(nonatomic, strong) void (^completion)(UIBackgroundFetchResult);
@property BOOL toComplete;

-(void)startLoadingDataForMessageWithID:(NSString*)messageID;
-(void)startLoadingDataForMessageWithID:(NSString *)messageID andCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler;

@end
