//
//  SingleMessageLoader.m
//  ego
//
//  Created by Jose V. Salazar on 1/4/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "MessangiAPI.h"
#import "SingleMessageLoader.h"
#import "Messangi.h"

@implementation SingleMessageLoader
@synthesize currentMessage, statusCode, statusDescription, currentStringValue, currentProperty, delegate, completion, toComplete;

- (id)init
{
    if (!self)
    {
        self = [super init];
    }
    
    return self;
}

- (void)startLoadingDataForMessageWithID:(NSString *)messageID andCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler
{
    toComplete = YES;
    completion = completionHandler;
    
    double timeStamp = ((double)[[NSDate date]timeIntervalSince1970])*1000;

    NSString *stringToSign = [NSString stringWithFormat:@"%@/%@/%F",messageID,[Messangi sharedInstance].clientID,timeStamp];

    NSString *encodedStringToSign = [stringToSign stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLPathAllowedCharacterSet]];

    NSString *signedString = [MessangiAPI encodeString:stringToSign usingKey:[Messangi sharedInstance].apiClientPrivateKey];

    NSString *urlString = [NSString stringWithFormat:@"%@/getMessage/%@/%@", PREFIX, encodedStringToSign, signedString];
    NSLog(@"urlString :%@",urlString);

    NSURLSession* mySession = [NSURLSession sharedSession];
    NSURLSessionTask* task = [mySession dataTaskWithURL:[NSURL URLWithString:urlString]
                                      completionHandler:^(NSData* data,
                                                          NSURLResponse* response, NSError* error) {
                                          if (error == nil)
                                          {
                                              NSLog(@"getMessage: completed successfully");
                                              NSXMLParser *parser = [[NSXMLParser alloc] initWithData:data];
                                              parser.delegate = self;
                                              [parser parse];
                                         }
                                          else
                                          {
                                              NSLog(@"getMessage: completed with error: %@", [error localizedDescription]);
                                          }
                                      }];
    [task resume];
}

- (void)startLoadingDataForMessageWithID:(NSString *)messageID
{
    toComplete = NO;
    
    double timeStamp = ((double)[[NSDate date]timeIntervalSince1970])*1000;

    NSString *stringToSign = [NSString stringWithFormat:@"%@/%@/%F",messageID,[Messangi sharedInstance].clientID,timeStamp];

    NSString *encodedStringToSign = [stringToSign stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLPathAllowedCharacterSet]];

    NSString *signedString = [MessangiAPI encodeString:stringToSign usingKey:[Messangi sharedInstance].apiClientPrivateKey];

    NSString *urlString = [NSString stringWithFormat:@"%@/getMessage/%@/%@", PREFIX, encodedStringToSign, signedString];
    NSLog(@"urlString :%@",urlString);

    NSURLSession* mySession = [NSURLSession sharedSession];
    NSURLSessionTask* task = [mySession dataTaskWithURL:[NSURL URLWithString:urlString]
                                      completionHandler:^(NSData* data,
                                                          NSURLResponse* response, NSError* error) {
                                          if (error == nil)
                                          {
                                              NSLog(@"getMessage: completed successfully");
                                              NSXMLParser *parser = [[NSXMLParser alloc] initWithData:data];
                                              parser.delegate = self;
                                              [parser parse];
                                          }
                                          else
                                          {
                                              NSLog(@"getMessage: completed with error: %@", [error localizedDescription]);
                                          }
                                      }];
    [task resume];
}

- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary *)attributeDict
{
    if ( [elementName isEqualToString:@"message"] ) {
        // currentPerson is an ABPerson instance variable
        currentMessage = [[UnstoredIncomingMessage alloc] init];
        return;
    }
    
    currentProperty = elementName;
    
    return;
    
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
    if (!self.currentStringValue) {
        // currentStringValue is an NSMutableString instance variable
        self.currentStringValue = [[NSMutableString alloc] initWithCapacity:50];
    }
    [self.currentStringValue appendString:string];
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
    
    if ( [elementName isEqualToString:@"message"] ) {
        return;
    }
    
    if ( [elementName isEqualToString:@"id"] ) {
        self.currentMessage.isRead = NO;
        self.currentMessage.receivedDate = [NSDate date];
        self.currentMessage.messageID = currentStringValue;
        
    } else if ( [elementName isEqualToString:@"subject"] ) {
        self.currentMessage.subject = currentStringValue;
    } else if ( [elementName isEqualToString:@"clientId"] ) {
        self.currentMessage.clientID = currentStringValue;
    } else if ([elementName isEqualToString:@"type"]){
        self.currentMessage.type = currentStringValue;
    } else if ( [elementName isEqualToString:@"text"] ) {
        self.currentMessage.text = currentStringValue;
        
        if (toComplete) {
            completion(UIBackgroundFetchResultNewData);
        }
     
        [self.delegate messageLoadFinishedReturningMessage:self.currentMessage];
        return;
    }
    currentStringValue = nil;
}

- (void)parserDidStartDocument:(NSXMLParser *)parser 
{
}

- (void)parser:(NSXMLParser *)parser parseErrorOccurred:(NSError *)parseError
{
    if (toComplete) {
        completion(UIBackgroundFetchResultFailed);
    }
}

@end
