package com.ogangi.messangi.android.demo.beacons;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.ogangi.messangi.android.demo.R;
import com.ogangi.messangi.android.demo.beacons.beacon.Beacon;

import java.util.ArrayList;
import java.util.List;

public class BeaconAdapter extends ArrayAdapter<Beacon.BeaconItem> {
    public BeaconAdapter(Context context, List<Beacon.BeaconItem> beacons) {
        super(context, 0, beacons);
    }

    public BeaconAdapter(Context context, ArrayList<Beacon.BeaconItem> beacons) {
        super(context, 0, beacons);
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        // Get the data item for this position
        Beacon.BeaconItem beacon = getItem(position);
        // Check if an existing view is being reused, otherwise inflate the view
        if (convertView == null) {
            convertView = LayoutInflater.from(getContext()).inflate(R.layout.beacon, parent, false);
        }
        // Lookup view for data population
        TextView title  = (TextView) convertView.findViewById(R.id.titleBC);
        TextView model  = (TextView) convertView.findViewById(R.id.model);
        TextView ssid   = (TextView) convertView.findViewById(R.id.ssid);
        TextView major  = (TextView) convertView.findViewById(R.id.major);
        TextView minor  = (TextView) convertView.findViewById(R.id.minor);
        ImageView image = (ImageView) convertView.findViewById(R.id.beacon_image);

        // Populate the data into the template view using the data object
        title.setText(beacon.title);
        model.setText(String.valueOf(beacon.model));
        ssid.setText(String.valueOf(beacon.ssid));
        major.setText(String.valueOf(beacon.major));
        minor.setText(String.valueOf(beacon.minor));
        image.setImageResource(R.drawable.beacon);
        // Return the completed view to render on screen
        return convertView;
    }
}
