package com.ogangi.messangi.android.demo.beacons.beacon;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by jtorres on 5/10/15.
 */
public class Beacon {
    /**
     * An array of Beacons.
     */
    public static List<BeaconItem> Beacons = new ArrayList<BeaconItem>();

    /**
     * A map of Beacons, by ID.
     */
    public static Map<String, BeaconItem> Beacons_map = new HashMap<String, BeaconItem>();

    public static void addItem(BeaconItem item) {
        Beacons.add(item);
        Beacons_map.put(item.id, item);
    }

    /**
     * A dummy item representing a piece of content.
     */
    public static class BeaconItem {
        public String id;
        public String title;
        public String ssid;
        public String model;
        public int major;
        public int minor;
        public String type;

        public BeaconItem(String id, String title, String ssid, String model, int major, int minor, String type) {
            this.id = id;
            this.title = title;
            this.ssid = ssid;
            this.model = model;
            this.major = major;
            this.minor = minor;
            this.type = type;
        }
    }

    public static BeaconItem getBeacon(String id){
        return Beacons_map.get(id);
    }

    public static BeaconItem getBeacon(int index){
        return Beacons.get(index);
    }
}