package com.ogangi.messangi.android.demo.beacons;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.support.v4.app.ListFragment;
import android.view.View;
import android.widget.ListView;

import com.ogangi.messangi.android.demo.beacons.beacon.Beacon;
import com.ogangi.messangi.android.sdk.Messangi;
import com.ogangi.messangi.android.sdk.MessangiService;
import com.ogangi.messangi.android.sdk.vo.BeaconVO;

import java.util.ArrayList;
import java.util.List;

/**
 * A fragment representing a list of Items.
 * <p/>
 * <p/>
 * Activities containing this fragment MUST implement the {@link OnFragmentInteractionListener}
 * interface.
 */
public class beaconFragment extends ListFragment {
    private static Object context;
    private OnFragmentInteractionListener mListener;
    private BeaconAdapter mAdapter;


    public static beaconFragment newInstance(Context ctx) {
        context = ctx;
        return new beaconFragment();
    }

    /**
     * Mandatory empty constructor for the fragment manager to instantiate the
     * fragment (e.g. upon screen orientation changes).
     */
    public beaconFragment() {
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mAdapter = new BeaconAdapter(getActivity(), Beacon.Beacons);
        setListAdapter(mAdapter);
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        this.setEmptyText("No beacon registered yet, please go to mesangi.com to register some Beacon");
        updateDataSet();
    }

    public void updateDataSet() {
        List<BeaconVO> beacons = null;
        try {
            beacons = Messangi.getInstance().getService().getBeacons();
        } catch (NullPointerException _n) {
            _n.printStackTrace();
            beacons = new ArrayList<>();
        }
        for (BeaconVO beacon : beacons) {
            Beacon.BeaconItem storageBeacon = Beacon.getBeacon(beacon.getRegionId());
            if (null == storageBeacon) {
                Beacon.BeaconItem tmp = new Beacon.BeaconItem(
                        beacon.getRegionId(),
                        beacon.getName(),
                        beacon.getUuid(),
                        beacon.getManufacturer(),
                        Integer.parseInt(beacon.getMajor()),
                        Integer.parseInt(beacon.getMinor()),
                        beacon.getEventType()
                );
                Beacon.addItem(tmp);
            }else{
                storageBeacon.title = beacon.getName();
                storageBeacon.ssid  = beacon.getUuid();
                storageBeacon.model = beacon.getManufacturer();
                storageBeacon.major = Integer.parseInt(beacon.getMajor());
                storageBeacon.minor = Integer.parseInt(beacon.getMinor());
                storageBeacon.type  = beacon.getEventType();
            }
        }
        mAdapter.notifyDataSetChanged();
    }

    @Override
    public void onAttach(Activity activity) {
        super.onAttach(activity);
        try {
            mListener = (OnFragmentInteractionListener) activity;
        } catch (ClassCastException e) {
            throw new ClassCastException(activity.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    @Override
    public void onListItemClick(ListView l, View v, int position, long id) {
        super.onListItemClick(l, v, position, id);
        if (null != mListener) {
            // Notify the active callbacks interface (the activity, if the
            // fragment is attached to one) that an item has been selected.
            mListener.onFragmentInteraction("Beacon", Beacon.getBeacon(position).id);
        }
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     */
    public interface OnFragmentInteractionListener {
        public void onFragmentInteraction(String type, String id);
    }
}

