package com.ogangi.messangi.android.demo.geofences;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.ogangi.messangi.android.demo.R;
import com.ogangi.messangi.android.demo.geofences.geofence.Geofence;

import java.util.ArrayList;
import java.util.List;

public class GeofenceAdapter extends ArrayAdapter<Geofence.GeofenceItem> {
    public GeofenceAdapter(Context context, List<Geofence.GeofenceItem> geofences) {
        super(context, 0, geofences);
    }

    public GeofenceAdapter(Context context, ArrayList<Geofence.GeofenceItem> geofences) {
        super(context, 0, geofences);
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        // Get the data item for this position
        Geofence.GeofenceItem geofence = getItem(position);
        // Check if an existing view is being reused, otherwise inflate the view
        if (convertView == null) {
            convertView = LayoutInflater.from(getContext()).inflate(R.layout.geofence, parent, false);
        }
        // Lookup view for data population
        TextView title    = (TextView) convertView.findViewById(R.id.titleGF);
        TextView radius   = (TextView) convertView.findViewById(R.id.radius);
        TextView distance = (TextView) convertView.findViewById(R.id.distance);
        ImageView image   = (ImageView) convertView.findViewById(R.id.list_image);

        // Populate the data into the template view using the data object
        title.setText(geofence.title);
        radius.setText(String.valueOf(geofence.radius));
        distance.setText(String.valueOf(geofence.distance));
        image.setImageResource(R.drawable.geofence);
        // Return the completed view to render on screen
        return convertView;
    }
}
