package com.ogangi.messangi.android.demo.geofences.geofence;

import android.location.Location;

import java.util.ArrayList;
import java.util.List;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by jtorres on 5/10/15.
 */
public class Geofence {
    private static float distanceBetween(double lat1, double long1, double lat2, double long2){
        Location selected_location=new Location("locationA");
        selected_location.setLatitude(lat1);
        selected_location.setLongitude(long1);
        Location near_locations=new Location("locationB");
        near_locations.setLatitude(lat2);
        near_locations.setLongitude(long2);
        return selected_location.distanceTo(near_locations);
    }

    /**
     * An array of Geofences.
     */
    public static List<GeofenceItem> Geofences = new ArrayList<GeofenceItem>();

    /**
     * A map of Geofence, by ID.
     */
    public static Map<String, GeofenceItem> Geofences_map = new HashMap<String, GeofenceItem>();

    public static void addItem(GeofenceItem item) {
        Geofences.add(item);
        Geofences_map.put(item.id, item);
    }

    public static void updateDistances(double latitude, double longitude){
        for (GeofenceItem geofence: Geofences){
            geofence.setDistance(distanceBetween(latitude,longitude,geofence.latitude,geofence.longitude));
        }
    }

    /**
     * A dummy item representing a piece of content.
     */
    public static class GeofenceItem {
        public String id;
        public String title;
        public float radius;
        public double latitude;
        public double longitude;
        public float distance;
        public String type;

        public GeofenceItem(String id, String title, float radius, double latitude, double longitude, String type) {
            this.id = id;
            this.title = title;
            this.radius = radius;
            this.latitude = latitude;
            this.longitude = longitude;
            this.type = type;
        }

        public void setDistance(float distance) {
            this.distance = distance;
        }
    }

    public static GeofenceItem getGeofence(String id){
        return Geofences_map.get(id);
    }

    public static GeofenceItem getGeofence(int index){
        return Geofences.get(index);
    }
}
