package com.ogangi.messangi.android.demo.inbox;

import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.ogangi.messangi.android.demo.R;
import com.ogangi.messangi.android.demo.inbox.notification.Notification;

import java.util.ArrayList;
import java.util.List;

public class NotificationAdapter extends ArrayAdapter<Notification.NotificationItem> {
    public NotificationAdapter(Context context, List<Notification.NotificationItem> notifications) {
        super(context, 0, notifications);
    }

    public NotificationAdapter(Context context, ArrayList<Notification.NotificationItem> notifications) {
        super(context, 0, notifications);
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        // Get the data item for this position
        Notification.NotificationItem notification = getItem(position);
        // Check if an existing view is being reused, otherwise inflate the view
        if (convertView == null) {
            convertView = LayoutInflater.from(getContext()).inflate(R.layout.notification, parent, false);
        }
        // Lookup view for data population
        TextView title = (TextView) convertView.findViewById(R.id.title);
        TextView content = (TextView) convertView.findViewById(R.id.content);
        TextView date = (TextView) convertView.findViewById(R.id.date);

        // Populate the data into the template view using the data object
        title.setText(notification.title);
        content.setText(notification.content);
        date.setText(notification.date.toString());

        int bgColor = Color.TRANSPARENT;
        if(notification.selected){
            bgColor = Color.parseColor("#d4d4d4");
        }
        convertView.setBackgroundColor(bgColor);

        // Return the completed view to render on screen
        return convertView;
    }
}
