package com.ogangi.messangi.android.demo.inbox.notification;

import android.content.Context;
import android.text.Html;

import com.ogangi.messangi.android.sdk.Messangi;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by jtorres on 5/10/15.
 */
public class Notification {
    /**
     * An array of Notifications.
     */
    public static List<NotificationItem> Notifications = new ArrayList<>();

    /**
     * A map of sample (dummy) items, by ID.
     */
    public static Map<String, NotificationItem> Notifications_map = new HashMap<>();

    public static void addItem(NotificationItem item) {
        Notifications.add(item);
        Notifications_map.put(item.id, item);
    }

    public static void deleteItem(String id){
        NotificationItem tmp = Notifications_map.get(id);
        Notifications.remove(tmp);
        Notifications_map.remove(tmp.id);
    }

    public static boolean itemToDelete() {
        for (NotificationItem notify : Notifications){
            if(notify.selected){
                return true;
            }
        }
        return false;
    }

    public static void deleteSelected(Context ctx) {
        ArrayList<NotificationItem> toRemove = new ArrayList();
        for (NotificationItem notify : Notifications) {
            if (notify.selected) {
                Messangi.getInstance().getService().deleteMessageFromLocalInbox(ctx,notify.id);
                Notifications_map.remove(notify.id);
                toRemove.add(notify);
            }
        }
        Notifications.removeAll(toRemove);
    }

    /**
     * A dummy item representing a piece of content.
     */
    public static class NotificationItem {
        public String id;
        public String title;
        public String content;
        public String html;
        public Date date;
        public String type;
        public Boolean newItem;
        public boolean selected = false;

        public NotificationItem(String id, String title, String html, Date date) {
            this.id      = id;
            this.title   = title;
            this.content = Html.fromHtml(html).toString();
            this.html    = "<!DOCTYPE html>" +
                    "<HTML lang=\"en\">" +
                    "   <HEAD>" +
                    "      <meta charset=\"utf-8\">"+
                    "      <TITLE>" +
                    "         Notification" +
                    "      </TITLE>" +
                    "   </HEAD>" +
                    "<BODY>" +
                        html +
                    "</BODY>" +
                    "</HTML>";
            this.date    = date;
        }

        public void setType(String type) {
            this.type = type;
        }

        public void setNewItem(Boolean newItem) {
            this.newItem = newItem;
        }

        @Override
        public String toString() {
            return content;
        }
    }

    public static NotificationItem getNotification(String id){
        return Notifications_map.get(id);
    }

    public static NotificationItem getNotification(int index){
        return Notifications.get(index);
    }
}
