package com.ogangi.messangi.demo;

import android.app.Activity;
import android.content.Context;
import android.webkit.JavascriptInterface;
import android.webkit.WebView;

/**
 * Created by jtorres on 11/6/15.
 */
public class JsInterface {
    private final WebView mWebView;
    private final Activity mActivity;
    Context mContext;
    private boolean ready;

    public void jsShowBeaconsSupported(){
        final String webUrl = "javascript:shownBeaconSupported(true)";
        mActivity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                mWebView.loadUrl(webUrl);
            }
        });
    }

    public void jsShowVersion(){

        String versionName;
        try {
            versionName = mContext.getPackageManager().getPackageInfo(mContext.getPackageName(), 0).versionName;
        } catch (Exception _e) {
            versionName = "0.0";
        }
        final String webUrl = "javascript:showVersion('"+versionName+"')";

        mActivity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                mWebView.loadUrl(webUrl);
            }
        });

    }

    JsInterface(Context c, Activity a,WebView w) {
        mContext = c;
        mWebView = w;
        mActivity = a;
        ready = false;
    }

    public boolean isReady(){
        return ready;
    }

    @JavascriptInterface
    public void getReady() {
        jsShowVersion();
        //jsShowBeaconsSupported();
        ready = true;
    }
}
