package com.ogangi.messangi.demo;



import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Map;
import java.util.Random;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.ComponentName;
import android.content.ServiceConnection;
import android.os.Build;
import android.os.IBinder;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.location.Location;
import android.view.View;
import android.view.View.OnClickListener;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;

import com.ogangi.messangi.android.sdk.Messangi;
import com.ogangi.messangi.android.sdk.MessangiListener;
import com.ogangi.messangi.android.sdk.MessangiLocationManager;
import com.ogangi.messangi.android.sdk.MessangiService;
import com.ogangi.messangi.android.sdk.Preferences;
import com.ogangi.messangi.android.sdk.Util;
import com.ogangi.messangi.android.sdk.vo.BeaconVO;
import com.ogangi.messangi.android.sdk.vo.GeoFenceVO;
import com.ogangi.messangi.android.sdk.vo.MessageVO;
import com.ogangi.messangi.android.sdk.vo.SubscriptionVO;

import com.google.android.gms.location.Geofence;

import org.json.JSONException;
import org.json.JSONObject;

public class MainActivity extends ActionBarActivity implements MessangiListener{
    final Context context = this;
    final Activity activity = this;
    private WebView mWebView;
    private JsInterface jsInterface;
    private boolean ready;

    MessangiService mService;
    static boolean mBound = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        //setContentView(R.layout.splash);

        // Messangi Credentials
        Messangi.getInstance().setAppName("Messangi");
        Messangi.getInstance().setApiClientPrivateKey("wzuuzVeVA4hR9Xc8kWQB");
        Messangi.getInstance().setClientId("D79BFFVx2TjXcJrrnktB");

        // GCM Credentials
        Messangi.getInstance().setGcmApiKey("AIzaSyDoThF8Mbagpnt4sDUy5ENf-GwfbU4zoEc");
        Messangi.getInstance().setGcmProjectId("554154250704");

        // Subscription manager
        Messangi.getInstance().setSubscriptionURL("https://www.messangi.com/messangi_mmc/rest/api");
        Messangi.getInstance().setSubscriptionInstanceId("8");

        Messangi.getInstance().addMessangiListener(this);
        Messangi.getInstance().registerDialog(this, this);
    }

    @Override
    public void postInit() {
        Messangi.getInstance().logEvent(this, "INIT", null);
        runOnUiThread(new Runnable() {
            public void run() {

                mWebView = (WebView) findViewById(R.id.output);
                WebSettings webSettings = mWebView.getSettings();
                webSettings.setJavaScriptEnabled(true);
                mWebView.loadUrl("file:///android_asset/www/index.html");
                jsInterface = new JsInterface(context,activity,mWebView);
                mWebView.addJavascriptInterface(jsInterface, "Android");

                if(!ready) {
                    mWebView.setWebViewClient(new WebViewClient() {
                        public void onPageFinished(WebView view, String url) {
                            new Thread() {
                                public void run() {

                                    //Se ve horrible pero solo el UIThread puede modificar el layout
                                    runOnUiThread(new Runnable() {
                                        @Override
                                        public void run() {
                                            ImageView im = (ImageView) findViewById(R.id.splash);
                                            im.setVisibility(View.GONE);
                                        }
                                    });

                                    ready = true;
                                    lastLocationShow();
                                    loadNotifications();
                                    loadGeofences();

                                }
                            }.start();
                        }
                    });
                }

                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
                    WebView.setWebContentsDebuggingEnabled(true);
                }
            }
        });
    }

    private void lastLocationShow(){
        Location lastKnowLocation = mService.getLastKnownLocation();
        JSONObject location = new JSONObject();
        if (lastKnowLocation != null && mWebView != null && ready && jsInterface.isReady()) {
            try {
                location.put("accuracy",lastKnowLocation.getAccuracy());
                location.put("latitude",lastKnowLocation.getLatitude());
                location.put("longitude",lastKnowLocation.getLongitude());
                location.put("provider",lastKnowLocation.getProvider());
            } catch (JSONException e) {
                e.printStackTrace();
            }
            jsUpdateLocation(location.toString());
        }
    }

    @Override
    public void onLocationChange(Location lastKnowLocation) {
        JSONObject location = new JSONObject();
        if (lastKnowLocation != null && mWebView != null && ready && jsInterface.isReady()) {
            try {
                location.put("accuracy",lastKnowLocation.getAccuracy());
                location.put("latitude",lastKnowLocation.getLatitude());
                location.put("longitude",lastKnowLocation.getLongitude());
                location.put("provider",lastKnowLocation.getProvider());
            } catch (JSONException e) {
                e.printStackTrace();
            }
            jsUpdateLocation(location.toString());
        }
    }

    @Override
    public void onGeofenceUpdate(String UpdateType, String geoFenceID) {

    }

    @Override
    public void onBeaconUpdate(String UpdateType, String beaconID) {

    }


    @Override
    public void updateFencesStatus(List<Geofence> geofences, int TriggerAcction, Location triggerLocation) {
        //loadGeofences();
    }

    public void jsAddGeofence(String geofence){
        final String webUrl = "javascript:addGeofence("+geofence+")";

        if(!this.isFinishing())
            // loadurl on UI main thread
            this.runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    mWebView.loadUrl(webUrl);
                }
            });
    }

    public void jsUpdateDistances(String location){
        final String webUrl = "javascript:updateDistances("+location+")";

        if(!this.isFinishing())
            // loadurl on UI main thread
            this.runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    mWebView.loadUrl(webUrl);
                }
            });
    }

    public void jsUpdateLocation(String location){
        jsUpdateDistances(location);
        final String webUrl = "javascript:updateLocation("+location+")";

        if(!this.isFinishing())
            // loadurl on UI main thread
            this.runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    mWebView.loadUrl(webUrl);
                }
            });
    }

    public void jsAddNotification(String notify){
        final String webUrl = "javascript:addNotification("+notify+")";

        if(!this.isFinishing())
            // loadurl on UI main thread
            this.runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    mWebView.loadUrl(webUrl);
                }
            });
    }

    public void jsClearInbox(){
        final String webUrl = "javascript:clearInbox()";

        if(!this.isFinishing())
            // loadurl on UI main thread
            this.runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    mWebView.loadUrl(webUrl);
                }
            });
    }

    public void loadNotifications(){
        List<MessageVO> storedPush = mService.getAllInboxMessages(getApplicationContext());
        for(MessageVO VO : storedPush) {
            JSONObject notify = new JSONObject();
            try {
                notify.put("id", VO.getMessageIDAux());
                notify.put("title", VO.getMessageTitle());
                notify.put("content", VO.getMessageContent());
                notify.put("date", VO.getMessageDate().getTime());
            } catch (JSONException e) {
                e.printStackTrace();
            }
            jsAddNotification(notify.toString());
        }
    }

    public void loadGeofences(){
        List<GeoFenceVO> geofences = mService.getGeofences();

        if(geofences.size() == 0){
            return;
        }
        for (GeoFenceVO geofence : geofences) {
            JSONObject gf = new JSONObject();
            String type;
            switch (geofence.getTransitionType()){
                case Geofence.GEOFENCE_TRANSITION_ENTER:
                    type = "ENTER";
                    break;
                case Geofence.GEOFENCE_TRANSITION_EXIT:
                    type = "EXIT";
                    break;
                default: //Both
                    type = "ENTER-EXIT";
            }
            try {
                gf.put("id",geofence.getId());
                gf.put("latitude",geofence.getLatitude());
                gf.put("longitude",geofence.getLongitude());
                gf.put("radius",geofence.getRadius());
                gf.put("type",type);
            } catch (JSONException e) {
                e.printStackTrace();
            }
            jsAddGeofence(gf.toString());
        }

        Location myLocation = mService.getLastKnownLocation();
        JSONObject location = new JSONObject();
        if (myLocation != null) {
            try {
                location.put("accuracy",myLocation.getAccuracy());
                location.put("latitude",myLocation.getLatitude());
                location.put("longitude",myLocation.getLongitude());
                location.put("provider",myLocation.getProvider());
            } catch (JSONException e) {
                e.printStackTrace();
            }
            jsUpdateLocation(location.toString());
        }
    }

    @Override
    public void pushReceived(MessageVO message) {
        Messangi.getInstance().logEvent(this, "PUSHRECEIVED", message.getMessageTitle());

        JSONObject notify = new JSONObject();
        try {
            notify.put("id",100);
            notify.put("title",message.getMessageTitle());
            notify.put("content",message.getMessageContent());
            notify.put("date", message.getMessageDate().getTime());
        } catch (JSONException e) {
            e.printStackTrace();
        }

        String tmp = notify.toString();
        if(ready) {
            jsAddNotification(tmp);
        }
    }

    @Override
    public void onBackPressed() {
        if (Preferences.getInstance(getApplicationContext()).getValue(Preferences.PHONE_NUMBER).trim().equals("")) {
            finish();
        } else {
            moveTaskToBack(true);
        }
    }

    @Override
    public boolean onPrepareOptionsMenu(Menu menu) {
        return true;
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        if (item.getItemId() == R.id.action_show_subscriptions) {
            List<SubscriptionVO> subscriptionList = Messangi.getInstance().getSubscriptionList();

            if (subscriptionList != null && subscriptionList.size() > 0) {
                String[] items = new String[subscriptionList.size()];
                boolean[] checkedItems = new boolean[subscriptionList.size()];

                for (int i = 0; i < subscriptionList.size(); i++) {
                    SubscriptionVO subscription = subscriptionList.get(i);
                    items[i] = subscription.getName();
                    if (mService.isSaved(subscription.getSubId())) {
                        checkedItems[i] = true;
                    }
                }

                final Context context = this;
                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setTitle("Subscriptions");

                builder.setMultiChoiceItems(items, checkedItems, new DialogInterface.OnMultiChoiceClickListener() {
                    public void onClick(DialogInterface dialog, final int which, boolean isChecked) {
                        if (!isChecked) {
                            new Thread() {
                                public void run() {
                                    mService.unsubscribeFromList(context,
                                            Messangi.getInstance().getSubscriptionList().get(which).getSubId());
                                    Messangi.getInstance().logEvent(MainActivity.this, "UNSUBSCRIBED",
                                            "" + Messangi.getInstance().getSubscriptionList().get(which).getSubId());
                                }
                            }.start();
                        } else {
                            new Thread() {
                                public void run() {
                                    mService.subscribeToList(context,
                                            Messangi.getInstance().getSubscriptionList().get(which).getSubId());
                                    Messangi.getInstance().logEvent(MainActivity.this, "SUBSCRIBED",
                                            "" + Messangi.getInstance().getSubscriptionList().get(which).getSubId());
                                }
                            }.start();
                        }
                    }
                }).setPositiveButton("Done", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int id) {
                    }
                });

                AlertDialog alert = builder.create();
                alert.show();
            } else {
                Util.info("SUBSCRIPTION LIST IS NULL '" + subscriptionList + "'");
            }
        } else if (item.getItemId() == R.id.action_send_response) {
            // custom dialog
            final Dialog dialog = new Dialog(this);
            dialog.setContentView(R.layout.dialog_response);
            dialog.setTitle("Send Response");

            Button dialogButton = (Button) dialog.findViewById(R.id.dialogButtonOK);
            // if button is clicked, close the custom dialog
            dialogButton.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View v) {
                    EditText eText = (EditText) dialog.findViewById(R.id.editText1);
                    if (!eText.getText().toString().isEmpty()) {
                        mService.sendResponse(context, eText.getText().toString(),
                                Preferences.getInstance(context).getValue(Preferences.PHONE_IMEI));
                        dialog.dismiss();
                    } else {
                        AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(context);
                        alertDialogBuilder.setTitle("Empty message");
                        alertDialogBuilder.setMessage("Message can not be empty!").setCancelable(false)
                                .setNegativeButton("Ok", new DialogInterface.OnClickListener() {
                                    public void onClick(DialogInterface dialog, int id) {
                                        dialog.cancel();
                                    }
                                });

                        AlertDialog alertDialog = alertDialogBuilder.create();
                        alertDialog.show();
                    }
                }
            });

            dialog.show();

        } else if (item.getItemId() == R.id.clear_inbox) {
            mService.deleteMessages(this);
            jsClearInbox();
        }
        return true;
    }

    @Override
    protected void onStart() {
        super.onStart();
        Messangi.getInstance().logEvent(this, "STARTED", null);
        // Bind to LocalService
        Intent intent = new Intent(this, MessangiService.class);
        startService(intent);
    }

    @Override
    protected void onPause() {
        super.onPause();
        Messangi.getInstance().logEvent(this, "PAUSED", null);
        if (mBound) {
            unbindService(mConnection);
            mBound = false;
        }
    }

    @Override
    protected void onStop() {
        super.onStop();
    }



    @Override
    protected void onResume() {
        super.onResume();
        Messangi.getInstance().logEvent(this, "RESUMED", null);

        if(!mBound) {
            Intent intent = new Intent(this, MessangiService.class);
            if (14 < Build.VERSION.SDK_INT) {
                bindService(intent, mConnection, Context.BIND_ABOVE_CLIENT);
            } else {
                bindService(intent, mConnection, Context.BIND_AUTO_CREATE);
            }
        }

    }

    @Override
    protected void onDestroy() {
        Messangi.getInstance().logEvent(this, "DESTROYED", null);
        super.onDestroy();
    }

    /** Defines callbacks for service binding, passed to bindService() */
    private ServiceConnection mConnection = new ServiceConnection() {

        @Override
        public void onServiceConnected(ComponentName className, IBinder service) {
            // We've bound to LocalService, cast the IBinder and get LocalService instance

            MessangiService.LocalBinder binder = (MessangiService.LocalBinder) service;
            mService = binder.getService();
            mService.init();
            mBound = true;
        }

        @Override
        public void onServiceDisconnected(ComponentName arg0) {
            mBound = false;
        }
    };


}
