package com.ogangi.messangi.demo;

import android.app.Notification;
import android.support.v4.app.NotificationCompat;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.provider.Settings;
import android.text.Html;

/**
 * Notification Engine for Show Notifications
 */
public class NotificationController {
    private static Context context = ApplicationContextProvider.getContext();

    public static void notify(String title, String message, int notifyID, int currentProgress, int maxProgress){
        Bitmap iconLarge = BitmapFactory.decodeResource(context.getResources(), R.mipmap.ic_launcher);
        NotificationManager manager = (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);
        NotificationCompat.Builder builder = new NotificationCompat.Builder(context)
                .setSmallIcon(R.mipmap.ic_launcher)
                .setLargeIcon(iconLarge)
                .setContentTitle(title)
                .setTicker(message)
                .setNumber(currentProgress)
                .setAutoCancel(true)
                .setProgress(maxProgress,currentProgress,false)
                .setContentText(message);


        if(currentProgress==1){
            builder.setSound(Settings.System.DEFAULT_NOTIFICATION_URI);
        }

        Intent notificationIntent = new Intent(context,MainActivity.class);
        PendingIntent pendingIntent = PendingIntent.getActivity(context,0,notificationIntent,0);
        Notification notification = builder.build();
        manager.notify(notifyID,notification);

    }

    public static void notify(String title, String message, int notifyID){
        Bitmap iconLarge = BitmapFactory.decodeResource(context.getResources(), R.mipmap.ic_launcher);
        Intent notificationIntent = new Intent(context,MainActivity.class);
        PendingIntent pendingIntent = PendingIntent.getActivity(context,0,notificationIntent,0);
        NotificationManager manager = (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);
        String htmlTextStr = Html.fromHtml(message).toString();
        NotificationCompat.Builder builder = new NotificationCompat.Builder(context)
                .setSmallIcon(R.mipmap.ic_launcher)
                .setLargeIcon(iconLarge)
                .setContentTitle(title)
                .setTicker(htmlTextStr)
                .setAutoCancel(true)
                .setContentText(htmlTextStr)
                .setContentIntent(pendingIntent)
                .setSound(Settings.System.DEFAULT_NOTIFICATION_URI);



        Notification notification = builder.build();
        manager.notify(notifyID,notification);

    }

    public static void notifyOpen(String title, String message, int notifyID){
        Bitmap iconLarge = BitmapFactory.decodeResource(context.getResources(), R.mipmap.ic_launcher);
        Intent notificationIntent = new Intent(context,MainActivity.class);
        PendingIntent pendingIntent =  PendingIntent.getActivity(context, 0, notificationIntent, PendingIntent.FLAG_UPDATE_CURRENT);
        NotificationManager manager = (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);
        String htmlTextStr = Html.fromHtml(message).toString();
        NotificationCompat.Builder builder = new NotificationCompat.Builder(context)
                .setSmallIcon(R.mipmap.ic_launcher)
                .setLargeIcon(iconLarge)
                .setContentTitle(title)
                .setTicker(htmlTextStr)
                .setAutoCancel(true)
                .setContentText(htmlTextStr)
                .setContentIntent(pendingIntent)
                .setSound(Settings.System.DEFAULT_NOTIFICATION_URI);



        Notification notification = builder.build();
        manager.notify(notifyID,notification);

    }
}
