//
//  AuthenticationViewController.m
//  Messangi
//
//  Created by Oscar Anzola on 5/23/14.
//  Copyright (c) 2014 Ogangi. All rights reserved.
//

#import "AuthenticationViewController.h"
#import "AppDelegate.h"
#import "CodeValidationViewController.h"
#import "CheckGeoFences.h"

@interface AuthenticationViewController ()

@property(nonatomic,copy)NSString *codeEntered;

@end

@implementation AuthenticationViewController

-(void)firstTimeSetupFinished{
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    [defaults setBool:NO forKey:@"isFirstTime"];
    [defaults synchronize];
    
    // FA: infinite loop
    
    /*CheckGeoFences *updateGeoFences = [[CheckGeoFences alloc] init];
    updateGeoFences.delegate = updateGeoFences;
    
    [updateGeoFences getUpdatedGeoFencesWithCompletionHandler:nil];*/
}

-(void) RegisterPhoneSucceeded:(BOOL)success withMessage:(NSString *)message{
    if (success) {
        //OJO: Validacion de codigo SMS
        self.status = REQUESTING_CODE;
    }
}

-(void)RegisterPhoneReturnedError:(NSString *)error
{
    UIAlertView * confirmAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                            message:error
                                                           delegate:self
                                                  cancelButtonTitle:NSLocalizedString(@"OK",nil)
                                                  otherButtonTitles:nil];
    
    [confirmAlert show];
}

-(void)ActivatePhoneSucceeded:(BOOL)success withMessage:(NSString *)message
{
    if (success) {
        [self firstTimeSetupFinished];
    }
    
}

-(void)ActivatePhoneReturnedError:(NSString *)error
{
    UIAlertView * confirmAlert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                            message:error
                                                           delegate:self
                                                  cancelButtonTitle:NSLocalizedString(@"OK",nil)
                                                  otherButtonTitles:nil];
    
    [confirmAlert show];
}


- (IBAction)sendValidationCodeButton:(id)sender {
    RegisterPhoneDataloader *rpdl = [[RegisterPhoneDataloader alloc]init];
    rpdl.delegate = self;
    [rpdl registerDeviceWithAreaCode:[NSString stringWithFormat:@"%@%@", _countryCodeTextField.text, _areaCodeTextField.text] andPhoneNumber:_numberTextField.text];
    
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    
    [defaults setObject:[NSString stringWithFormat:@"%@%@%@", _countryCodeTextField.text, _areaCodeTextField.text,_numberTextField.text] forKey:@"clientPhoneNumber"];
    [defaults synchronize];
}

- (IBAction)cancelMobileNumberValidation:(id)sender {
}


- (IBAction)cancelCodeValidation:(UIStoryboardSegue *)segue {
}

- (IBAction)processCodeValidation:(UIStoryboardSegue *)segue {
    if ([[segue identifier] isEqualToString:@"ProcessValidationCode"]) {
        CodeValidationViewController *vc = [segue sourceViewController];
        _codeEntered = vc.codeEnteredTextField.text;
        //Validate code
        RegisterPhoneDataloader *rpdl = [[RegisterPhoneDataloader alloc]init];
        rpdl.delegate = self;
        [rpdl activatePhoneWithCode:_codeEntered];
    }
}

- (IBAction)countryCodetextField:(id)sender {
    _sendValidationCodeButton.enabled = NO;
}

- (IBAction)areaCodeTextField:(id)sender {
    _sendValidationCodeButton.enabled = NO;
}

- (IBAction)numberTextField:(id)sender {
    _sendValidationCodeButton.enabled = YES;
}

-(void)checkAllMandatoryFields
{
    if ([_countryCodeTextField.text length] || [_areaCodeTextField.text length] || [_numberTextField.text length]) {
            _sendValidationCodeButton.enabled = YES;
    } else {
        _sendValidationCodeButton.enabled = NO;
    }
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [self checkAllMandatoryFields];
	[textField resignFirstResponder];

	return YES;
}


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    [self.view setBackgroundColor:[UIColor colorWithPatternImage:[UIImage imageNamed:@"LS-BG.png"]]];
    self.navigationController.navigationBarHidden = YES;
    _enterMobilePhoneNumberLabel.text = NSLocalizedString(@"NumberEntry", @"Prompts user to enter mobile number:");
    _countryCodeLabel.text = NSLocalizedString(@"Country", @"Country");
    _areaCodeLabel.text = NSLocalizedString(@"Area", @"Area");
    _phoneNumberLabel.text = NSLocalizedString(@"Number", @"Phone Number");
    [_sendValidationCodeButton setTitle:NSLocalizedString(@"SendValidationButton", @"Sends user validation code") forState:UIControlStateNormal];
    [_sendValidationCodeButton.titleLabel setTextAlignment: NSTextAlignmentCenter];
    [_cancelMobileNumberValidationButton setTitle:NSLocalizedString(@"CancelButton", @"A cancel button") forState:UIControlStateNormal];
    [_cancelMobileNumberValidationButton.titleLabel setTextAlignment: NSTextAlignmentCenter];
    _sendValidationCodeButton.enabled = NO;
    [_countryCodeTextField becomeFirstResponder];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
