package com.ogangi.messangi.android.sdk;

import android.content.Context;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;

import java.util.HashMap;

/**
 * Preference for messangiAPI
 */
@SuppressWarnings("unused")
public class Preferences {
	public static final String LOCATION_UPDATE_TYPE = "locationUpdateType";
	public static final String LOCATION_UPDATE_TIME = "locationUpdateTime";
	private static SharedPreferences sp = null;
    private static SharedPreferences.Editor spe = null;
    public static String FS = System.getProperty("file.separator");

    public static final String WAKE_ON_PUSH_ACTIVITY = "wakeOnPushActivity";
    public static final String MESSANGI_API_CLIENT_PRIVATE_KEY = "messangiAPIClientPrivateKey";
    public static final String MESSANGI_API_CLIENT_ID = "messangiAPIClientID";
    public static final String SUBSCRIPTIONS_URL = "subscriptionsURL";
    public static final String SUBSCRIPTIONS_INSTANCE_ID = "subscriptionsInstanceID";
    public static final String APP_NAME = "nameApp";
    public static final String ACCOUNT_LOGIN = "accountLogin";
    public static final String PHONE_IMEI = "accountPassword";
    public static final String ACCOUNT_KEY = "accountKey";
    public static final String PHONE_NUMBER = "phoneNumber";
    public static final String KEY_SINCE = "keySince";
    public static final String KEY_VALIDITY_LENGTH = "keyValidityLength";
    public static final String STARTON_SUSCRIPTION = "startOnSuscription";
    public static final String ACTIVATION_CODE = "activationCode";
    public static final String NUMBER_PREFIX = "numberPrefix";
    public static final String REGISTRATION_ID = "registrationIdGoogle";
    public static final String REMOTE_API_URL = "remoteApiUrl";
    public static final String GCM_PLATFORM_ID = "gcmIdRegistration";
    public static final String GCM_PROJECT_ID = "serverPushId";
    public static final String MESSANGI_REGISTRATION_KEY = "messangiRegistration";
    public static final String GCM_API_KEY = "messangiApiKey";
    public static final String LATITUDE = "latitude";
    public static final String LONGITUDE = "longitude";
    public static final String GPS_ENABLED = "gpsEnabled";
    public static final String PHONE_ACTIVATED = "phoneActivated";

    public static final String GETLOC_DISABLED = "getlocDisabled";

	public static final String LOGEVENTS_ALLOWED = "logEventsAllowed";
    public static Preferences prfrcs = null;
    private static HashMap<String, String> airValues = new HashMap<>();

	public static Preferences getInstance(Context ctx) {
		if (prfrcs == null) {
			return new Preferences(ctx);
		} else {
			return prfrcs;
		}
	}

    private Preferences(Context ctx) {
		if (sp == null) {
			sp = PreferenceManager.getDefaultSharedPreferences(ctx);
			//sp = ctx.getSharedPreferences("LYO30", Context.MODE_PRIVATE);
		}
		if (spe == null) {
			spe = sp.edit();
		}
		spe.putLong(KEY_VALIDITY_LENGTH, 2592000000l); // 1 month
		spe.putString(ACTIVATION_CODE, "");
		spe.putString(NUMBER_PREFIX, "58");
		spe.putString(REMOTE_API_URL, "https://api.messangi.com/messangi-staging/rest/message/");
		if (Messangi.getInstance().getAppName() != null) {
			spe.putString(APP_NAME, Messangi.getInstance().getAppName());
			spe.putString(GCM_API_KEY, Messangi.getInstance().getGcmApiKey());
			spe.putString(GCM_PROJECT_ID, Messangi.getInstance().getGcmProjectId());
			spe.putString(MESSANGI_API_CLIENT_ID, Messangi.getInstance().getClientId());
			spe.putString(MESSANGI_API_CLIENT_PRIVATE_KEY, Messangi.getInstance().getApiClientPrivateKey());
			spe.putString(SUBSCRIPTIONS_URL, Messangi.getInstance().getSubscriptionURL());
			spe.putString(SUBSCRIPTIONS_INSTANCE_ID, Messangi.getInstance().getSubscriptionInstanceId());
		}
		spe.apply();
		prfrcs = this;
	}

	/**
	 * @deprecated Use getString
	 * @param key Key String for get
	 * @return The String saved or empty string if no exist
	 */
    public String getValue(String key) {
		if (airValues.containsKey(key)) {
			return airValues.get(key);
		}
		return sp.getString(key, "");
	}

	/**
	 * @deprecated Use getBoolean instead
	 * @param key
	 * @return The boolean Saved
	 */
	public boolean getBoolValue(String key) {
		if (airValues.containsKey(key)) {
			return Boolean.parseBoolean(airValues.get(key));
		}
		return sp.getBoolean(key, false);
	}




	public int getInt(String key, int defaultValue){
		if (airValues.containsKey(key)) {
			return Integer.parseInt(airValues.get(key));
		}
		return sp.getInt(key, defaultValue);
	}

	public int getInt(String key){
		if (airValues.containsKey(key)) {
			return Integer.parseInt(airValues.get(key));
		}
		return sp.getInt(key, -1);
	}


	public long getLong(String key, long defaultValue){
		if (airValues.containsKey(key)) {
			return Long.parseLong(airValues.get(key));
		}
		return sp.getLong(key, defaultValue);
	}

	public long getLong(String key){
		if (airValues.containsKey(key)) {
			return Long.parseLong(airValues.get(key));
		}
		return sp.getLong(key, -1);
	}


	public boolean getBoolean(String key, boolean defaultValue) {
		if (airValues.containsKey(key)) {
			return Boolean.parseBoolean(airValues.get(key));
		}
		return sp.getBoolean(key, defaultValue);
	}

	public boolean getBoolean(String key) {
		if (airValues.containsKey(key)) {
			return Boolean.parseBoolean(airValues.get(key));
		}
		return sp.getBoolean(key, false);
	}


	public String getString(String key, String defaultValue){
		if (airValues.containsKey(key)) {
			return airValues.get(key);
		}
		return sp.getString(key, defaultValue);
	}

	public String getString(String key){
		if (airValues.containsKey(key)) {
			return airValues.get(key);
		}
		return sp.getString(key, "");
	}



	public void saveValue(String key, int value) {
		spe.putInt(key, value);
		spe.commit();
	}

	public void saveValue(String key, long value) {
		spe.putLong(key, value);
		spe.commit();
	}

    public void saveValue(String key, boolean value) {
		spe.putBoolean(key, value);
		spe.commit();
	}

	public void saveValue(String key, String value) {
		spe.putString(key, value);
		spe.commit();
	}



    public void removeValue(String key) {
		spe.remove(key);
		spe.commit();
	}



    public void saveAirValue(String key, String value) {
		airValues.put(key, value);
	}

}

