package com.ogangi.messangi.android.sdk;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.telephony.SmsMessage;

/**
 * A BroadcastReceiver for wait SMS validation in Registration phone number
 * @Bug Podria dar problemas con varias aplicaciones que tengan el messangiSDK activo
 */
public class SMSReceiver extends BroadcastReceiver {
	@Override
	public void onReceive(Context context, Intent intent) {
		Bundle bundle = intent.getExtras();
		Object messages[] = (Object[]) bundle.get("pdus");
		SmsMessage smsMessage[] = new SmsMessage[messages.length];
		String uuid = null;
		for (int n = 0; n < messages.length; n++) {
			smsMessage[n] = SmsMessage.createFromPdu((byte[]) messages[n]);
			String txt = smsMessage[n].getMessageBody();
			if (txt.contains("RM-VALIDATION-CODE:")) {
				uuid = txt.substring(txt.indexOf("RM-VALIDATION-CODE: ") + 20).trim();
				break;
			}
		}
		Preferences.getInstance(context).saveValue(Preferences.ACTIVATION_CODE, uuid);
	}
}

