package com.ogangi.messangi.android.sdk.vo;

/**
 * @deprecated in favor of Native Location Object
 * Represents a Geographic point,
 * providing access to latitude and longitude
 */
@SuppressWarnings("unused")
public class GeoPointVO {
	private double latitude;
	private double longitude;

    /**
     * Constructs a new GeoPointVO with latitude and longitude.
     * @param latitude String with latitude to parse in Double
     * @param longitude String with longitude to parse in Double
     */
	public GeoPointVO(String latitude, String longitude) {
		this.latitude = Double.parseDouble(latitude);
		this.longitude = Double.parseDouble(longitude);
	}

    /**
     * Constructs a new GeoPointVO with latitude and longitude.
     * @param latitude Double with latitude
     * @param longitude Double with longitude
     */
	public GeoPointVO(double latitude, double longitude) {
		this.latitude = latitude;
		this.longitude = longitude;
	}

    /**
     * Returns the latitude of GeoPointVO Object
     * @return Double with latitude
     */
	public double getLatitude() {
		return latitude;
	}

    /**
     * Sets the latitude of GeoPointVO Object
     * @param latitude Double with latitude
     */
	public void setLatitude(double latitude) {
		this.latitude = latitude;
	}

    /**
     * Returns the longitude of GeoPointVO Object
     * @return Double with Longitude
     */
	public double getLongitude() {
		return longitude;
	}

    /**
     * Sets the longitude of GeoPointVO Object
     * @param longitude Double with longitude
     */
	public void setLongitude(double longitude) {
		this.longitude = longitude;
	}

}
